import { ComponentPropField, ConditionalField } from '../../component-blocks';
import { DocumentFeatures } from '../../views';
import { DocumentFeaturesForNormalization } from '../document-features-normalization';
import { Relationships } from '../relationship';
import { ChildField } from './api';
export declare function findChildPropPaths(value: Record<string, any>, props: Record<string, ComponentPropField>): {
    path: (string | number)[] | undefined;
    options: ChildField['options'];
}[];
export declare function assertNever(arg: never): void;
export declare function getPropsForConditionalChange(newValue: Record<string, any>, oldValue: Record<string, any>, prop: ConditionalField<any, any, any>, relationships: Relationships): Record<string, any>;
export declare type DocumentFeaturesForChildField = {
    kind: 'inline';
    inlineMarks: 'inherit' | DocumentFeatures['formatting']['inlineMarks'];
    documentFeatures: {
        links: boolean;
        relationships: boolean;
    };
    softBreaks: boolean;
} | {
    kind: 'block';
    inlineMarks: 'inherit' | DocumentFeatures['formatting']['inlineMarks'];
    softBreaks: boolean;
    documentFeatures: DocumentFeaturesForNormalization;
};
export declare function getDocumentFeaturesForChildField(editorDocumentFeatures: DocumentFeatures, options: ChildField['options']): DocumentFeaturesForChildField;
export declare function getChildFieldAtPropPath([key, ...restOfPath]: (string | number)[], values: Record<string, any>, props: Record<string, ComponentPropField>): undefined | ChildField;
export declare function clientSideValidateProp(prop: ComponentPropField, value: any): boolean;
